#ifndef RGR_CFG_H__
#define RGR_CFG_H__

#include <stdint.h>

// offsets in the configuration message
// | CODE | PARAMS .... |
#define	RGR_CONFIG_CODE_OFFSET					0
#define	RGR_CONFIG_PARAMS_OFFSET				1

// configuration command codes
#define	RGR_CONFIG_INDICATION_LEDS_CODE			0x01
#define	RGR_CONFIG_COMMAND_LEDS_CODE			0x02
#define	RGR_CONFIG_COMMAND_MOTOR_CODE			0x03

// offsets and size inside the storage
#define	RGR_CONFIG_PATTERN_OFFSET				0
#define	RGR_CONFIG_INDICATION_LEDS_OFFSET		RGR_CONFIG_PATTERN_OFFSET + RGR_CONFIG_PATTERN_SIZE
#define	RGR_CONFIG_COMMAND_LEDS_OFFSET			RGR_CONFIG_INDICATION_LEDS_OFFSET + RGR_CONFIG_INDICATION_LEDS_SIZE
#define	RGR_CONFIG_COMMAND_MOTOR_OFFSET			RGR_CONFIG_COMMAND_LEDS_OFFSET + RGR_CONFIG_COMMAND_LEDS_SIZE

#define RGR_CONFIG_START_OFFSET					RGR_CONFIG_PATTERN_OFFSET

#define RGR_CONFIG_PATTERN_SIZE					2
#define	RGR_CONFIG_INDICATION_LEDS_SIZE			3
#define	RGR_CONFIG_COMMAND_LEDS_SIZE			3
#define	RGR_CONFIG_COMMAND_MOTOR_SIZE			1

#define	RGR_CONFIG_SIZE							RGR_CONFIG_PATTERN_SIZE + \
												RGR_CONFIG_INDICATION_LEDS_SIZE + \
												RGR_CONFIG_COMMAND_LEDS_SIZE + \
												RGR_CONFIG_COMMAND_MOTOR_SIZE \
												
// storage geometry params
#define	RGR_CONFIG_BLOCK_SIZE					PSTORAGE_MIN_BLOCK_SIZE
#define RGR_CONFIG_BLOCK_COUNT					1

typedef struct
{
	uint8_t pattern[RGR_CONFIG_PATTERN_SIZE];
	uint8_t leds_indication_intensity[RGR_CONFIG_INDICATION_LEDS_SIZE];
	uint8_t leds_command_intensity[RGR_CONFIG_COMMAND_LEDS_SIZE];
	uint8_t motor_intensity;
} rgr_cfg_config_t;


uint32_t rgr_cfg_init(void);
void rgr_cfg_save(void);
void rgr_cfg_load(void);
//uint32_t rgr_cfg_save(uint8_t *p_data, uint8_t length);

#endif // RGR_CFG_H__
